/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package complejos;

import java.awt.Color;
import java.awt.Graphics;

/**
 *
 * @author krios
 */
public class complejo {

    private double real,  imag;
    private Color micolor;
    private String minombre;

    public enum coord {

        POL, REC
    };

    public complejo() {
        real = imag = 0;
    }
    
    public complejo(complejo base) {
        this(base.real, base.imag);
        this.micolor = Color.BLACK;
        this.minombre = "X";
    }
    
    @SuppressWarnings("empty-statement")
    public complejo(String textrealofase, String teximagomod, coord coordenadas) {
        if (textrealofase.length() == 0) {
            textrealofase += "0";
        }
        if (teximagomod.length() == 0) {
            teximagomod += "0";
        }
        if (coordenadas == coord.REC) {
            this.imag = Double.valueOf(teximagomod).doubleValue();
            this.real = Double.valueOf(textrealofase).doubleValue();
        } else {
            this.imag = Double.valueOf(teximagomod).doubleValue() * Math.sin(Double.valueOf(textrealofase).doubleValue());
            this.real = Double.valueOf(teximagomod).doubleValue() * Math.cos(Double.valueOf(textrealofase).doubleValue());
            ;
        }

        micolor = Color.BLACK;// por defecto negros

        minombre = "x";

    }

    public complejo(double real, double imag) {
        this.imag = imag;
        this.real = real;
        micolor = Color.BLACK;// por defecto negros

        minombre = "x";
    }

    public complejo(complejo base, Color micolor, String minombre) {
        this(base.real, base.imag);
        this.micolor = micolor;
        this.minombre = minombre;
    }

    public double getReal() {
        return this.real;
    }
    ;

    public double getImag() {
        return this.imag;
    }
    ;

    @Override
    public String toString() {
        String signo = new String();
        if (imag >= 0) {
            signo += "+";
        } else {
            signo = "";
        }
        return Double.toString(Math.round(this.real * 100) / 100.0) + " " + signo + Double.toString(Math.round(imag * 100) / 100.0) + " j";

    }
    ;

    public String toStringpolares() {

        return Double.toString(Math.round(this.modulo() * 100) / 100.0) + " {" + Double.toString(Math.round(this.faserads() * 100) / 100.0) + " rads}";

    }
    ;

    public String toStringcompleto() {

        return this.toString() + " || " + this.toStringpolares();

    }
    ;

    public complejo operar(complejo x, char operacion) {
        complejo nuevo;
        switch (operacion) {
            case '+':
                nuevo = suma(x);
                break;
            case '-':
                nuevo = resta(x);
                break;
            case '*':
                nuevo = multiplicacion(x);
                break;
            case '/':
                nuevo = division(x);
                break;
            default:
                nuevo = new complejo(0, 0);
        }
        return nuevo;
    }
    ;

    public complejo suma(complejo x) {
        return new complejo(x.real + this.real, x.imag + this.imag);
    }
    ;

    public complejo resta(complejo x) {
        return new complejo(this.real - x.real, this.imag - x.imag);
    }
    ;

    public complejo multiplicacion(complejo x) {
        return new complejo(x.real * this.real - x.imag * this.imag, this.real * x.imag + x.real * this.imag);
    }
    ;

    public complejo multiplicacion(double x) {
        return new complejo(this.real * x, this.imag * x);
    }
    ;

    public complejo estirarencoger(double x) {
        // x>1 estira, x<1 encoge
        this.real=this.real * x;
        this.imag=this.imag * x;
        return this;
    }
    ;
    
    public complejo girar(double rads) {
        // rads<0 giro clockwise
        double nuevafase;
        double modulo=this.modulo();
        nuevafase=this.faserads()+rads;
        this.real=modulo*Math.cos(nuevafase);
        this.imag=modulo*Math.sin(nuevafase);
        return this;
    }
    ;
    
    
    public complejo division(complejo x) {
        return new complejo((x.real * this.real + x.imag * this.imag) / x.moduloalcuadrado(), (this.imag * x.real - x.imag * this.real) / x.moduloalcuadrado());
    }
    ;

    public double modulo() {
        return Math.sqrt(this.real * this.real + this.imag * this.imag);
    }
    ;

    public double moduloalcuadrado() {
        return this.modulo() * this.modulo();
    }
    ;

    public double faserads() {
        if (this.real >= 0) {
            return Math.atan(this.imag / this.real);
        } else {
            return (Math.atan(this.imag / this.real) + (Math.PI));
        }
    }
    ;

    public double fasedegs() {
        return Math.toDegrees(faserads());
    }
    ;

    public void pintar(Graphics g, double escala) {
        double xextremo = this.getReal() * escala;
        double yextremo = -this.getImag() * escala;
        

        g.setColor(micolor);
        g.drawLine(0, 0, (int) xextremo, (int) yextremo);
        /*
         * Polygon pico = crearpico(escala);
         g.drawPolygon(pico);
         */
        g.drawString(minombre+" ["+this+"]", (int) xextremo, (int) yextremo);
    }
    
    /* 
    private String quitaespacios(String complejotext){
    int i;
    String sinespacios=new String();
    for(i=0; i< complejotext.length();i++){
    if(complejotext.charAt(i)!=' '){
    sinespacios +=complejotext.charAt(i);
    }
    }
    return sinespacios;
    }*/
}
